package ru.landgrafhomyak.utility.highlevel_try_finally.tests

import org.testng.annotations.Test
import ru.landgrafhomyak.utility.highlevel_try_finally.safeAutoClose1

@Test
class KotlinStdlibDependencyTest {
	@Test
	fun testNoKotlinStdlib() {
		try {
			if (KotlinVersion.CURRENT.major != -1)
				throw AssertionError("Kotlin stdlib still in runtime classpath")
		} catch (_: LinkageError) {
		}
	}

	private class CustomTestException : RuntimeException()
	private object CustomUnit

	private fun throw7throwFn() {
		safeAutoClose1(finally = { throw CustomTestException() }, action = { throw CustomTestException() })
	}

	@Suppress("NOTHING_TO_INLINE")
	private inline fun throw7throwIn() {
		safeAutoClose1(finally = { throw CustomTestException() }, action = { throw CustomTestException() })
	}

	@Test(dependsOnMethods = ["testNoKotlinStdlib"])
	fun testAutoCloseFn() {
		try {
			throw7throwFn()
		} catch (_: CustomTestException) {
		} catch (le: LinkageError) {
			throw AssertionError("safeAutoClose still has dependency on kotlin stdlib", le)
		}
	}

	@Test(dependsOnMethods = ["testNoKotlinStdlib"])
	fun testAutoCloseIn() {
		try {
			throw7throwIn()
		} catch (_: CustomTestException) {
		} catch (le: LinkageError) {
			throw AssertionError("safeAutoClose still has dependency on kotlin stdlib", le)
		}
	}
}